package pps.core.middle.service;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.middle.service.IThirdActivePowerCloudService;
import pps.cloud.middle.service.data.third_active_power.GetThirdActivePowerViewInput;
import pps.cloud.middle.service.data.third_active_power.GetThirdActivePowerViewOutput;
import pps.core.middle.entity.ThirdActivePowerEnt;
import pps.core.middle.mapper.ThirdActivePowerMapper;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XListResult;

import java.util.List;

/**
 * 实际功率
 *
 * @author ZWT
 * @date 2024/10/19 15:36
 */
@XService
public class ThirdActivePowerCloudServiceImpl implements IThirdActivePowerCloudService {

    @Override
    public XListResult<GetThirdActivePowerViewOutput> getThirdActivePowerList(XContext context, GetThirdActivePowerViewInput input) {
        ThirdActivePowerMapper mapper = context.getBean(ThirdActivePowerMapper.class);
        List<ThirdActivePowerEnt> list = mapper.selectList(new QueryWrapper<ThirdActivePowerEnt>()
                .select("STATION_NAME", "SUM( PHOTOVOLTAIC_POWER ) AS PHOTOVOLTAIC_POWER", "CREATE_DATE")
                .groupBy("STATION_NAME", "STATION_ID", "CREATE_DATE")
                .eq(ObjectUtil.isNotNull(input.getCreateDate()), "CREATE_DATE", input.getCreateDate())
        );
        return XListResult.success(XCopyUtils.copyNewList(list, GetThirdActivePowerViewOutput.class));
    }
}
